/* nwtests.c 20-May-96 */

/****************************************************************
 * (C)opyright (C) 1993,1996  Martin Stover, Marburg, Germany   *
 ****************************************************************/

#include "nwnet.h"

#include <fcntl.h>
#include <share.h>

static int get_err_a(int err, int rax, int rbp, int rsi)
{
  hardretn(-1); /* Failed */
  // hardresume(3); /* Retry , Abort, Ignore */
  return(-1);   /* Never Reached */
}


static int usage(void)
{
  fprintf(stderr, "usage:\t%s n\n", funcname);
  fprintf(stderr, "\tn = test number:\n" );
  return(-1);
}

#if 0
static int func_tests_xxx(int argc, char *argv[], int mode)
{
  int level     = ncp_17_02(NWCONN, 6);
  int dirhandle = alloc_temp_dir_handle(0, "SYS:", 'd', NULL);
  int result    = -1;
  uint8  *path  = (argc < 2) ? "SYS:\\TMP" : argv[1];
  if (dirhandle > -1) {
    result = ncp_16_02(dirhandle, "SYSTEM/", NULL, NULL, NULL, NULL);
    result = ncp_16_02(dirhandle, "SYSTEM", NULL, NULL, NULL, NULL);
  }
  fprintf(stdout, "dirhandle=%d, result=%d\n", dirhandle, result);
  result = redir_device_drive(0x4, "u:", path);
  fprintf(stdout, "redir path=%s, result=%d\n", path, result);

  path="Q1";
  result = redir_device_drive(0x3, "LPT1", path);
  fprintf(stdout, "redir path=%s, result=%d\n", path, result);

  {
    int k =-1;
    uint8 devname[20];
    uint8 remotename[130];
    int  devicetyp;
    while ((result = list_redir(++k, &devicetyp, devname, remotename)) > -1){
       fprintf(stdout, "index=%d, dev=%s(%d), %s result=%d\n",
            k, devname, devicetyp, remotename, result);
    }
  }
  if (level > -1) (void) ncp_17_02(NWCONN, level);
  return(0);
}
#endif

#if 0
static void tesopen(int mode)
{
  int fd = _rtl_open("xyzzz", mode);
  if (fd > -1) close(fd);
}


static int func_tests_xx(int argc, char *argv[], int mode)
{
 // int level     = ncp_17_02(NWCONN, 6);
#if 1
  tesopen(O_RDONLY);
  tesopen(O_RDONLY | SH_COMPAT);
  tesopen(O_RDWR);
  tesopen(O_RDWR   | SH_COMPAT);
#endif
  tesopen(O_RDONLY | O_DENYWRITE );
  tesopen(O_RDONLY | O_DENYREAD  );
  tesopen(O_RDWR   | O_DENYWRITE );
  tesopen(O_RDWR   | O_DENYREAD  );
  tesopen(O_RDONLY | O_DENYWRITE | O_DENYREAD );
  tesopen(O_RDWR   | O_DENYREAD  | O_DENYWRITE);

//  if (level > -1) (void) ncp_17_02(NWCONN, level);
  return(0);
}
#endif

#if 1

static void dhtest(int drive)
{
  int dirhandle1 = alloc_permanent_dir_handle(0, "SYS:", drive, NULL);
  int dirhandle2 = alloc_permanent_dir_handle(0, "SYS:\\PUBLIC", drive, NULL);
  int status;
  uint8 path[256];
  status = get_dir_path(dirhandle1, path);
  if (status < 0) path[0]='\0';
  fprintf(stdout, "dr=%d, dh1=%2d, %3d, '%s'\n", drive, dirhandle1, status, path);

  status = get_dir_path(dirhandle2, path);
  if (status < 0) path[0]='\0';
  fprintf(stdout, "dr=%d, dh2=%2d, %3d, '%s'\n", drive, dirhandle2, status, path);
}

static int func_tests_x(int argc, char *argv[], int mode)
{
  int level     = ncp_17_02(NWCONN, 6);
  dhtest('I');
  dhtest('i');
  if (level > -1) (void) ncp_17_02(NWCONN, level);
  return(0);
}

#endif

static void write_sh_value(int fd, int value)
{
  if (0 != lseek(fd, 0, SEEK_SET)
    || sizeof(value) != write(fd, &value, sizeof(value)))
     perror("seek/write error in share file");
}


int accesses1[] ={ 
        O_RDONLY,              O_WRONLY,             O_RDWR,
        O_RDONLY|O_DENYNONE,   O_WRONLY|O_DENYNONE,  O_RDWR|O_DENYNONE,
        O_RDONLY|O_DENYWRITE,  O_WRONLY|O_DENYWRITE, O_RDWR|O_DENYWRITE,
        O_RDONLY|O_DENYREAD,   O_WRONLY|O_DENYREAD,  O_RDWR|O_DENYREAD,
        O_RDONLY|O_DENYALL,    O_WRONLY|O_DENYALL,   O_RDWR|O_DENYALL
        };

static int do_open1(int access)
{
  return( _rtl_open("xx", access));
}

static int func_tests_1(int opts)
{
  int count_access = sizeof(accesses1)/sizeof(int);
  int i=0;
  int fh_s = -1;
  
  if (opts) {
    fh_s = open("xx.sha", O_RDWR | O_CREAT | O_DENYNONE | O_BINARY, 0666 );
    if (fh_s < 0) {
      perror("cannot open share file xx.sha");
      return(1);
    }
    if (opts&1) { // server
      write_sh_value(fh_s, count_access);
      sleep(1);
    }
  }
  
  while (i < count_access) {
    int fd1  = -1;
    int flag = 0;

    if ( !opts ) {
      fd1  = do_open1(accesses1[i]);
      flag = fd1 != -1;
    
    } else if (opts & 1) {    // Server
      fd1  = do_open1(accesses1[i]);
      flag = fd1 != -1;
      if (flag) 
        write_sh_value(fh_s, i);

    } else if (opts & 2) {  // Clients
      int value;
      while (1) {
        if (  0 == lseek(fh_s, 0, SEEK_SET)
           && sizeof(value) == read(fh_s, &value, sizeof(value))
           && value != -1 )
         break;
        sleep(1);
      }

      i = value;
      flag = (value < count_access );
    }
    
    if (!(i%3))
      printf("--\n");
    
    if (flag) {
      if ( ! (opts&1) ) { // nicht beim Server
        int k;
        printf("%02x |", accesses1[i]);
        for (k=0; k < count_access; k++)
        {
          int l;
          for (l=0; l < 1; ++l)
          {
            int fd2 = do_open1(accesses1[k]);
            if (fd2 != -1)
              close(fd2);
            printf("%02x(%c) |", accesses1[k], fd2 != -1 ? '+' : '-');
          //printf("%02x,%02x |", accesses[k], code);
          }
        }
        
        if (opts & 2)  // client
          write_sh_value(fh_s, -1);
        
        printf("\n");
      } else {   // server
        int value;
        while (1) {
          if ( 0 == lseek(fh_s, 0, SEEK_SET)
             && sizeof(value) == read(fh_s, &value, sizeof(value))
             && value == -1 )
           break;
          sleep(1);
        }
      }
      
      if (fd1 > -1) 
        close(fd1);
    }
    if (!(opts&2)) // not client
      ++i;
  } // while
  
  if (opts & 1)     // Server
    write_sh_value(fh_s, count_access);
  
  if (fh_s > -1)
    close(fh_s);
  
  return(0);
}

int accesses[] = { 0x11,     0x12,    0x13,
                   0x1,      0x2,     0x3,
                   0x1|0x8,  0x2|0x8, 0x3|0x8,
                   0x1|0x4,  0x2|0x4, 0x3|0x4,
                   0x1|0xc,  0x2|0xc, 0x3|0xc
                   };

static int do_open(char *fhandle, int access)
{
 int result = ncp_4c(fhandle, 0, 6, access, "SYS:TMP\\XX");
 return(result);
}

static int func_tests_0(int opts)
{
  int count_access = sizeof(accesses)/sizeof(int);
  int i    =  0;
  int fh_s = -1;

  if (opts) {
    fh_s = open("xx.sha", O_RDWR | O_CREAT | O_DENYNONE | O_BINARY, 0666 );
    if (fh_s < 0) {
      perror("cannot open share file xx.sha");
      return(1);
    }
    if (opts&1) { // server
      write_sh_value(fh_s, count_access);
      sleep(1);
    }
  }
  
  while (i < count_access)  {
    char fh1[6];
    int flag = 0;
    if ( !opts ) {
      flag = !do_open(fh1, accesses[i]);
    
    } else if (opts & 1) {    // Server
      flag = !do_open(fh1, accesses[i]);
      
      if (flag) 
        write_sh_value(fh_s, i);
      else {
        char buf[200];
        sprintf(buf, "open 'xx' failed access=%02x\n", accesses[i]);
        perror(buf);
      }

    } else if (opts & 2) {  // Clients
      int value;
      while (1) {
        if ( 0 == lseek(fh_s, 0, SEEK_SET)
            && sizeof(value) == read(fh_s, &value, sizeof(value))
            && value != -1 )
         break;
        sleep(1);
      }

      i = value;
      flag = (value < count_access );
    }

    if (!(i % 3))
      printf("--\n");

    if (flag) {
      if ( ! (opts&1) ) { // nicht beim Server
        int k;
        printf("%02x |", accesses[i]);
        for (k=0; k < count_access; k++)
        {
          int l;
          for (l=0; l < 1; ++l)
          {
            char fh2[6];
            int code = do_open(fh2, accesses[k]);
            if (!code)
              ncp_42(fh2);
            printf("%02x(%c) |", accesses[k], !code ? '+' : '-');
          //printf("%02x,%02x |", accesses[k], code);
          }
        }
        if (opts & 2)  // client
          write_sh_value(fh_s, -1);
        
        printf("\n");
      } else {   // server
        int value;
        while (1) {
          if ( 0 == lseek(fh_s, 0, SEEK_SET)
             && sizeof(value) == read(fh_s, &value, sizeof(value))
             && value == -1 )
           break;
          sleep(1);
        }
      }
      if (!(opts&2))  // nicht beim Client
        ncp_42(fh1);
    }

    if (! (opts&2) ) 
      i++;
  }

  if (opts & 1)     // Server
    write_sh_value(fh_s, count_access);
  
  if (fh_s > -1)
    close(fh_s);
}


static int func_tests_2(int opts)
{
  int count_access = sizeof(accesses)/sizeof(int);
  int i    =  0;
  int ii   =  0;
  while (i < count_access)  {
    char fh1[6];
    int flag = !do_open(fh1, accesses[i]);
    if (flag) {
      int key;
      int iii = i;
      printf("    opened with mode: %02x\n", accesses[i]);
      key = getch();
      ncp_42(fh1);
      if (key == '-') i = ii - 1;
      else if (key == 'k') break;
      ii = iii;
    } else
      printf("not opened with mode: %02x\n", accesses[i]);
    ++i;
  }
}


int func_tests(int argc, char *argv[], int mode)
{
  if (argc > 1) {
    int func = atoi(argv[1]);
    int opts = 0;
    if (argc > 2) {
      switch (argv[2][0]) {
        case 's':
        case 'S':
           opts |= 1;
           break;

        case 'c':
        case 'C':
           opts |= 2;
           break;
      }
    }
    harderr(*get_err_a);
    switch (func) {
      case 0: return func_tests_0(opts);
      case 1: return func_tests_1(opts);
      case 2: return func_tests_2(opts);
      default: 
        break;
    }
  }
  return usage() ;
}

